
// source: stackoverflow
// use gcc -O2
// TODO: use std::chrono, std::vector

#include <algorithm>
#include <ctime>
#include <iostream>

const unsigned N = 20000;

int main(int argc, char *argv[])
{
    const unsigned arraySize = 32768;
    int data[arraySize];

    // Generate (pseudo)random data
    for (unsigned c = 0; c < arraySize; ++c)
        data[c] = std::rand() % 256;

    if(argc>1) {
        // With this, the next loop runs faster (with branch predictor)
        std::cout << "sorted\t";
        std::sort(data, data + arraySize);
    }

    // Test
    clock_t start = clock();
    long long sum = 0;

    for (unsigned i = 0; i < N; ++i) {
        // Primary loop
        for (unsigned c = 0; c < arraySize; ++c) {
            if (data[c] >= 128) // conditional jump
                sum += data[c];
        }
    }

    double elapsedTime = static_cast<double>(clock() - start) / CLOCKS_PER_SEC;

    std::cout << "time = " << elapsedTime << " s\n";
    std::cout << "sum  = " << sum << std::endl;
}
