
// example of non-portable use of union

#include <stdio.h>
#include <float.h>      // FLT_EPSILON,FLT_MIN,FLT_MAX
#include <math.h>       // INFINITY,NAN

typedef union {
  float f;
  struct { // item order depends on implementation
    unsigned int mantissa : 23;
    unsigned int exponent : 8;
    unsigned int sign : 1;
  }; // anonymous struct
} IEEE_float;

int main() {
    float x[] = { 0, 1, 2, 10, 256, -1, 0.1, 3.1415926,
                  FLT_EPSILON, 1-FLT_EPSILON,
                  FLT_MIN, FLT_MAX,
                  INFINITY, -INFINITY, NAN };
    for(int i=0; i<(sizeof(x)/sizeof(x[0])); ++i) {
        IEEE_float f = { .f=x[i] };
        printf("%10.8g:\t", f.f);
        printf("sign = %u\t", f.sign);
        printf("exponent = %u\t", f.exponent);
        printf("mantissa = 0x%x\n", f.mantissa);
    }
}
