
// swap first and third word in string
// swap i-th and j-th word in string
// inspiration for exam

#include <stdio.h>
#include <ctype.h>              // isspace
#include <stdbool.h>
#include <string.h>             // strlen, memmove

static void swapchar(char *c1, char *c2)
{
    char tmp = *c1;
    *c1 = *c2;
    *c2 = tmp;
}

char *searchword(char *s, int *len)
{
    while (isspace(*s))
        ++s;                    // skip spaces

    if (*s == '\0')
        return NULL;            // word not found

    if (len != NULL) {          // we want word length
        const char *end = s;
        while (*end != '\0' && !isspace(*end))
            ++end;
        *len = end - s;         // assign returned length
    }
    return s;                   // return word start
}

#if 0
static int min(int a, int b)
{
    return (a < b) ? a : b;
}

bool swapwords(char *s)
{
    int l1;
    char *w1 = searchword(s, &l1);      // first
    if (w1 == NULL)
        return false;

    int lx;
    char *wx = searchword(w1 + l1, &lx);        // second
    if (wx == NULL)
        return false;

    int l2;
    char *w2 = searchword(wx + lx, &l2);        // third
    if (w2 == NULL)
        return false;

    int l = min(l1, l2);
    for (int i = 0; i < l; ++i)
        swapchar(w1++, w2++);

    if (l1 > l) {
        // "xxxxyy  aaaa"
        --w2;
        for (int i = 0; i < l1 - l; ++i) {
            char c = *w1;
            memmove(w1, w1 + 1, w2 - w1);
            *w2 = c;
        }
    } else if (l2 > l) {
        // "xxxx  aaaabb"
        for (int i = 0; i < l2 - l; ++i) {
            char c = *w2;
            memmove(w1 + 1, w1, w2 - w1);
            *w1++ = c;
            w2++;
        }
    }
    return true;
}

int main()
{
    char s[][100] = {
        " abcde1    fghijkl2 xxxxxx ",
        " abcdefg1  hijkl2   xxxxxx ",
        "a bb",
        "aa b",
        "a b",
        "a",
        "",
    };
    for (int i = 0; i < sizeof(s) / sizeof(s[0]); ++i) {
        printf("\"%s\"\n", s[i]);
        bool r = swapwords(s[i]);
        printf("\"%s\" -> %s\n\n", s[i], r ? "true" : "false");
    }
}
#else
bool swapwords(char *s, unsigned i1, unsigned i2)
{
    int l1;
    char *w1;                   // first word
    int l2;
    char *w2;                   // second word
    if (i1 == i2)
        return true;
    int l = 0;
    char *w = s;
    for (int i = 0; (w = searchword(w + l, &l)) != NULL; ++i) {
        if (i == i1) {
            l1 = l;
            w1 = w;
        }
        if (i == i2) {
            l2 = l;
            w2 = w;
            break;
        }
    }
    if (w == NULL)
        return false;

    if (l1 != l2)
        return false;

    for (int i = 0; i < l1; ++i)
        swapchar(w1++, w2++);

    return true;
}

int main()
{
    char s[][100] = {
        " abc1  def2 xxxxxx ",
        " abcd1  ef2 xxxxx ",
        "aa bb",
        "a b",
        "a",
        "",
    };
    for (int i = 0; i < sizeof(s) / sizeof(s[0]); ++i) {
        printf("\"%s\"\n", s[i]);
        bool r = swapwords(s[i], 0, 1);
        printf("\"%s\" -> %s\n\n", s[i], r ? "true" : "false");
    }
}
#endif
