// faktorial.c
// Jazyk C -- faktoriál s kontrolou přetečení
// TODO: uintmax_t

#include <stdio.h>
#include <limits.h>

// factorial - výpočet faktoriálu čísla n
// - při chybě (n<0 nebo překročení meze) vrací nulu
unsigned long long factorial(int n)
{
    unsigned long long vysledek = 1;
    if (n < 0)
        return 0;               // chybová hodnota
    for (int i = 1; i <= n; i++) {
        // POZOR: přetečení se musí zkontrolovat před násobením
        if (vysledek > ULLONG_MAX / i)  // test překročení mezí
            return 0;           // chybová hodnota
        vysledek *= i;
    }
    return vysledek;
}

// program tiskne faktoriály čísel od 0 do 20
int main(void)
{
  int n;
  printf("-------------------------\n");
  for(n=0; n<99; n++) {
    unsigned long f = factorial(n);
    printf("%2d! = %19ld %s\n", n, f, (f==0)?"OVERFLOW":"");
    if(f==0) break;
  }
  printf("-------------------------\n");
}

