/*  sum.c
 *  Jazyk C -- funkce AtoL() a příklad použití
 */

#include <stdio.h>
#include <ctype.h>

long AtoL(const char *s);         /* deklarace funkce AtoL */

int main(int argc, char *argv[]) {
  long suma = 0;                  /* inicializace */
  int  i;

  for(i=1; i<argc; i++)           /* pro všechny argumenty programu */
    suma += AtoL(argv[i]);        /* sčítá hodnoty */

  printf ("%ld\n", suma);         /* tisk součtu */
  return 0;
}

/*
 *  funkce AtoL - převede řetězec na číslo long
 *  v případě chyby vrací nulu, nekontroluje přetečení
 */
long AtoL(const char *s) {             /* definice funkce AtoL */
  long cislo = 0;
  int  zaporne = 0;

  while(isspace(*s)) s++;              /* přeskočí úvodní mezery */

  if(*s=='-' || *s=='+') {             /* zpracuje případné znaménko */
    zaporne = (*s=='-');
    s++;
  }
  if(*s=='0') {
    s++;
    if(toupper(*s)=='X') {             /* šestnáctkové číslo */
      s++;
      while(isxdigit(*s)) {            /* dokud jsou číslice */
        int c = toupper(*s++);         /* číslice */
        cislo = 16 * cislo;
        if(c>='A')
          cislo += c - 'A' + 10;
        else
          cislo += c - '0';
      }
    }
    else {                             /* osmičkové číslo */
      while( *s > '0' && *s < '8')     /* dokud jsou číslice */
        cislo = 8 * cislo + (*s++ - '0');
    }
  }
  else                                 /* desítkové číslo */
    while(isdigit(*s))                 /* dokud jsou číslice */
      cislo = 10 * cislo + (*s++ - '0');

  return zaporne ? -cislo : cislo;
}

