#!/bin/sh
# simple multi-target Makefile generator

echo
echo "CXXFLAGS = -std=c++17 -g -O2 -Wall"
echo "CFLAGS   = -std=c11 -g -O2 -Wall"
echo "LDLIBS   = -lm"     ## some examples need math library
echo
echo "############################################################"
echo "# C++ programs:"
for i in *.cc; do
    if [ -f "$i" ]; then
        echo "PROGS += ${i%%.cc}"
    fi
done
echo "# C programs:"
for i in *.c; do
    if [ -f "$i" ]; then
        echo "PROGS += ${i%%.c}"
    fi
done
echo "############################################################"
echo
echo "all: \$(PROGS)"
echo
echo "run: \$(PROGS)"
echo '	@for i in $^ ; do echo "===== $$i ====="; ./$$i; done'
echo
echo "clean:"
echo "	rm -f \$(PROGS)"
echo
echo "pack: clean"
echo '	(                                               \'
echo '	NAME=$$(basename $$(pwd)); cd ..;               \'
echo '	tar czvf $$NAME-$$(date -I).tar.gz ./$$NAME/    \'
echo '	)'
echo

