
// use GCC argument -ldl

#include <stdio.h>
#include <dlfcn.h>      // libdl interface

void *handle;
int (*fun1)(int);
double (*fun2)(double);
const char *err;

int main() {
    //////////////////////////////////////////////////////////////
    printf(__FILE__": pripojeni ./libtest1.so\n");
    handle = dlopen("./libtest1.so",RTLD_LAZY);
    err = dlerror();
    if(err) {
        fprintf(stderr, "dlopen: error %s\n", err);
        return 1;
    }
    fun1 = dlsym(handle, "fun1"); 
    err = dlerror();
    if(err) {
        fprintf(stderr, "dlsym: error %s\n", err);
        return 3;
    }

    int r1 = fun1(5); /* call */

    printf(__FILE__": odpojeni ./libtest1.so\n");
    dlclose(handle); // TODO: test return code

    //////////////////////////////////////////////////////////////
    printf(__FILE__": pripojeni ./libtest2.so\n");
    handle = dlopen("./libtest2.so",RTLD_LAZY);
    err = dlerror();
    if(err) {
        fprintf(stderr, "dlopen: error %s\n", err);
        return 1;
    }
    fun2 = dlsym(handle, "fun2"); 
    /* if(!fun1) return 2; */
    err = dlerror();
    if(err) {
        fprintf(stderr, "dlsym: error %s\n", err);
        return 3;
    }

    double r2 = fun2(5); /* call */

    printf(__FILE__": odpojeni ./libtest2.so\n");
    dlclose(handle);
}
