
// test of trigonometric functions precision
// link with math library: gcc -lm

#include <stdio.h>
#include <math.h>

#ifndef M_PI
#    define M_PI 3.14159265358979323846
#endif

double difference(double x) {
    return sin(x) - sin(x + 2*M_PI);    // math: should be zero
}

int main() {
    printf("Partial/Total loss of precision\n");
    printf("sin(x)-sin(x+2*\\pi) for x=10^{n}, n=1..18\n");
    double x = 1.0;
    for(int i=1; i<=18; ++i) {
        x *= 10.0;
        printf("%3d: % g\n", i, difference(x));
    }
}
