/*
 *  prototyp.c -- ukázka programu s chybou!
 *
 *  demonstrace nutnosti používat prototypy funkcí v ISO C
 *  funguje v ANSI C, C90, C99, C11, C18
 *  TODO: C23 už toto nedovoluje = chyba
 *        doplnit ještě chybu v typu funkce, pokud není int
 *
 */

#include <stdio.h>      /* prototyp  int printf(const char *, ...)   */

int main()              /* funkce main musí být jen jedna            */
{

  printf("Chybné volání funkce bez deklarace\n");

  /* bez prototypu překladač implicitně předpokládá int f() */
  printf("Volání bez prototypu: i = f(1)\n");
  int i = f(1); /* funkce f dostane argument typu int,
                   ale má ve skutečnosti parametr typu double
                   -- hrubá CHYBA */
  /* překladač varuje (gcc -Wall)
   * prototype.c:18: warning: implicit declaration of function `f'
   */
  printf("Výsledek: %d\n", i);

  /* prototyp překladač informuje jaké jsou parametry/typ funkce */
  int f(double x);

  printf("\nKorektní volání s prototypem: i = f(1)\n");
  i = f(1);  /* překladač automaticky provede konverzi: (double)1
                a volání proběhne O.K. */
  printf("Výsledek: %d\n", i);

  return 0;
}

/* definice funkce -- může být v jiném modulu */
int f(double x)
{
    printf("Funkce pracuje s parametrem x = %f\n", x);
    return x; /* tato funkce vrací celočíselnou hodnotu x */
              /* Poznámka: zkuste si  x == 1e20 */
}

